package com.bonus.file.service.impl;

import com.bonus.file.entity.FileDetails;
import com.bonus.file.service.ISysFileService;
import com.bonus.file.utils.FileDownloadUtils;
import com.bonus.file.utils.FileUploadUtils;
import com.bonus.system.api.domain.SysFile;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * 本地文件存储
 * 
 * @author bonus
 */
@Service
@ConditionalOnProperty(name = "storage.type", havingValue = "file", matchIfMissing = true)
public class LocalSysFileServiceImpl implements ISysFileService
{
    /**
     * 资源映射路径 前缀
     */
    @Value("${file.prefix}")
    public String localFilePrefix;

    /**
     * 域名或本机访问地址
     */
    @Value("${file.domain}")
    public String domain;
    
    /**
     * 上传文件存储在本地的根路径
     */
    @Value("${file.path}")
    private String localFilePath;

    /**
     * 本地文件上传接口
     * 
     * @param file 上传的文件
     * @return 访问地址
     * @throws Exception
     */
    @Override
    public SysFile uploadFile(MultipartFile file) throws Exception
    {
        String name = FileUploadUtils.upload(localFilePath, file);
        String url = domain + localFilePrefix + name;
        return SysFile.builder().url(url).name(name).build();
    }

    @Override
    public List<SysFile> uploadFiles(MultipartFile[] files) throws Exception {
        List<SysFile> sysFiles = new ArrayList<>();
        for (MultipartFile file : files) {
            SysFile sysFile = uploadFile(file);
            sysFiles.add(sysFile);
        }
        return sysFiles;
    }

    @Override
    public void downloadFile(HttpServletResponse response, String urlStr) throws Exception
    {
         FileDownloadUtils.downloadFile(response, urlStr);
    }

    /**
     * 从给定的URL下载文件并将其保存到指定的目标位置。
     *
     * @param response 请求响应。
     * @param urlStr   要下载文件的URL地址。
     * @throws Exception 如果在下载过程中遇到任何异常，例如网络问题、文件写入问题等。
     */
    @Override
    public void downloadFilesAsZip(HttpServletResponse response, List<String> urlStr) throws Exception {

    }

    @Override
    public void deleteFile(String urlStr) throws Exception
    {
        String regex = String.format("^(.*?%s)", localFilePrefix);
        String updatePath = urlStr.replaceFirst(regex, localFilePath);
        Path path = Paths.get(updatePath);
        if (Files.exists(path)){
            try {
                Files.deleteIfExists(path);
            }catch (IOException e){
                throw new Exception(e.getMessage(), e);
            }
        }else {
            throw new Exception("删除文件时文件不存在");
        }
    }

    /**
     * 删除指定URL所指向的文件。
     *
     * @param urlStr 要删除文件的URL地址。
     * @return 布尔值，指示文件删除是否成功。如果文件被成功删除，则返回true；否则返回false。
     * @throws Exception 如果在删除文件的过程中遇到错误，例如网络问题、文件不存在或没有删除权限等。
     */
    @Override
    public void deleteFiles(List<String> urlStr) throws Exception {
            for (String url : urlStr) {
                deleteFile(url);
            }
    }

    /**
     * 获取指定文件夹下的所有文件夹和文件。
     *
     * @param folderPath 要获取文件夹和文件的父文件夹路径（例如 "folder1/"）
     * @return 返回一个包含所有文件夹和文件路径的集合
     */
    @Override
    public Set<FileDetails> getFilesAndSubfolders(String folderPath) {
        return Collections.emptySet();
    }

    /**
     * 创建文件夹（通过上传带有路径的文件）
     *
     * @param folderPath 文件夹路径（例如 "folder1/subfolder/"）
     */
    @Override
    public void createFolder(String folderPath) {

    }

    /**
     * 删除指定路径的所有对象，从而删除“文件夹”。
     *
     * @param folderPath 文件夹路径（例如 "folder1/subfolder/"）
     */
    @Override
    public void deleteFolder(String folderPath) {

    }
}
